'''
Created on Aug 26, 2010

@author: donal
'''
from cocos.sprite import Sprite
from cocos.layer import Layer
import pyglet

import data

class Actor(Sprite):

    def __init__(self):
        pass
    
    def update(self):
        pass

class PlayerActor(Sprite):
    FACING_LEFT = 0
    FACING_RIGHT = 1
    images = dict()
    state = 'walking'
    facing = 0
    
    def __init__(self, state='standing', position=(0,0), facing=0):
        self.state = state
        standing = pyglet.image.load(data.filepath('dude_01.png'))
        self.images['standing'] = standing.texture
        
        jumping = (pyglet.image.load(img_filename) for img_filename in [data.filepath('dude_jump_01.png'), data.filepath('dude_jump_02.png'), data.filepath('dude_jump_03.png')])
        self.images['jumping'] = pyglet.image.Animation.from_image_sequence(jumping, 0.1, False)
        
        landing = (pyglet.image.load(img_filename) for img_filename in [data.filepath('dude_jump_03.png'), data.filepath('dude_jump_02.png'), data.filepath('dude_jump_01.png')])
        self.images['landing'] = pyglet.image.Animation.from_image_sequence(landing, 0.1, False)

        walking = (pyglet.image.load(img_filename) for img_filename in [data.filepath('dude_01.png'), data.filepath('dude_02.png'), data.filepath('dude_03.png')])
        self.images['walking'] = pyglet.image.Animation.from_image_sequence(walking, 0.1)

        punching = (pyglet.image.load(img_filename) for img_filename in [data.filepath('dude_punch_01.png'), data.filepath('dude_punch_02.png'), data.filepath('dude_punch_03.png')])
        self.images['punching'] = pyglet.image.Animation.from_image_sequence(punching, 0.1)

        if (facing == self.FACING_LEFT):
            self.facing = True
        else:
            self.facing = False
        super(PlayerActor, self).__init__(self.images[self.state].get_transform(flip_x=self.facing), position)
        self.image_anchor_y = 0
        
    def update(self):

        if (self.state in self.images):
            self.sprite = Sprite(self.images[self.state])

    def changeState(self, state='standing'):
        print 'changeState: ', state
        if (state in self.images):
            self.state = state
        else:
            self.state = 'standing'
        self.image = self.images[self.state].get_transform(flip_x=self.facing)


class ThugActor(Sprite):
    FACING_LEFT = 1
    FACING_RIGHT = 0
    images = dict()
    state = 'walking'
    facing = 0
    def __init__(self, state='standing', position=(0,0), facing=0):
        self.state = state
        standing = pyglet.image.load(data.filepath('thug_01.png'))
        self.images['standing'] = standing.texture
        
        walking = (pyglet.image.load(img_filename) for img_filename in [data.filepath('thug_walk_01.png'), data.filepath('thug_walk_02.png'), data.filepath('thug_walk_03.png'), data.filepath('thug_walk_04.png')])
        self.images['walking'] = pyglet.image.Animation.from_image_sequence(walking, 0.1)

        punching = (pyglet.image.load(img_filename) for img_filename in [data.filepath('thug_punch_01.png'), data.filepath('thug_punch_02.png'), data.filepath('thug_punch_03.png')])
        self.images['punching'] = pyglet.image.Animation.from_image_sequence(punching, 0.1)

        if (facing == self.FACING_LEFT):
            self.facing = True
        else:
            self.facing = False
            
        super(ThugActor, self).__init__(self.images[self.state].get_transform(flip_x=self.facing), position)
        self.image_anchor_y = 0
        
    def update(self):
        if (self.state in self.images):
            self.sprite = Sprite(self.images[self.state])
        if sprite_intersect(self, self.parent.player):
            print 'punch player'
            self.changeState('punching')
        elif self.state != 'walking':
            print 'just walk'
            self.changeState('walking')

    def changeState(self, state='standing'):
        print 'changeState: ', state
        if (state in self.images):
            self.state = state
        else:
            self.state = 'standing'
        self.image = self.images[self.state].get_transform(flip_x=self.facing)
            
class BoxActor(Sprite):
    available_player_actions = dict()
    
    def __init__(self, positing):
        pass
