'''
Created on Aug 26, 2010

@author: donal
'''
from cocos.menu import *
from cocos.layer import Layer
from cocos.director import *
from cocos.scene import Scene
from cocos.sprite import Sprite
from FuzzyFroggy.PlayerLayer import PlayerLayer
from cocos.text import *
#from FuzzyFroggy.GameEnd import GameEnd
import data
import pyglet

class GameEnd(Layer):
    is_event_handler = True
    def __init__(self):
        super(GameEnd, self).__init__()
        x, y = director.get_window_size()
        self.text = Label("Game End", (x/2, y/2))
        self.add(self.text)
        
    def on_mouse_press(self, x, y, btns, mods):
        scene = Scene(MainMenu())
        director.replace(scene)
        
    def on_key_pess(self):
        scene = Scene(MainMenu())
        director.replace(scene)
        
class MenuBackground(Layer):
    def __init__(self):
        super(MenuBackground, self).__init__()
        self.image = pyglet.image.load(data.filepath('title_screen.png'))
        self.background = Sprite(self.image)
        x, y = director.get_window_size()
        self.background.position = (x / 2, y / 2)
        self.add(self.background, 0)
        
class MainMenu(Menu):
    def __init__( self ):
        super(MainMenu, self).__init__()
        self.menu_valign = BOTTOM
        self.menu_halign = RIGHT

        self.font_item_selected['color'] = (0, 0, 0, 200)
        self.font_item_selected['font_size'] = 50
        self.font_item['color'] = (0, 0, 0, 150)
        self.font_item['font_size'] = 50
        
        items = []
        
        items.append(MenuItem('Play', self.on_new_game))
        items.append(MenuItem('Quit', self.on_quit))
        self.create_menu(items, selected_effect=shake(), unselected_effect=shake_back(),
                          layout_strategy=fixedPositionMenuLayout(
                            [(200, 50), (450, 50)]))
    
    def on_new_game(self):
        
        
        director.push(Scene(GameEnd()))     
        #director.push(Scene(PlayerLayer()))
        director.run(Scene(PlayerLayer()))
        
    def on_quit(self):
        director.pop()

        