'''
Created on Aug 26, 2010

@author: donal
'''

from cocos.menu import *
from cocos.director import *
from cocos.sprite import Sprite

from cocos.tiles import *

from cocos.layer import *
from cocos.scene import Scene
from cocos.actions import *

import pyglet
from pyglet.resource import *
from pyglet.window import key

from vector import distv

from FuzzyFroggy.Actors import *
from FuzzyFroggy.ActorActions import *
import data

class MouseCursorRect():
    position = (0,0)
    width = 0
    height = 0
    def __init__(self, position=(0,0), width=0, height=0):
        self.position = position
        self.width = width
        self.height = height


class PlayerLayer(Layer):
    is_event_handler = True
    action_menu = None
    action_queue = [PlayerMove((50,115), 3)]
    player = None
    stage_objects = []
    manager = None
    
    action_menu = None
    
    bg_0 = None
    bg_1a = None
    bg_1b = None
    bg_1c = None
    bg_2a = None
    bg_2b = None
    bg_3a = None
    bg_3b = None
    
    def __init__(self):
        super(PlayerLayer, self).__init__()
        
        self.initBackgroundAnimation()
        
#        while (p_x < win_width):
#            print win_width, p_x
#            tmp = Sprite(pyglet.image.load(data.filepath('platform_01.png')))
#            tmp.position = (p_x, 5)
#            tmp.image_anchor_y = 0
#            self.platforms.append(tmp)
#            self.add(tmp, z=0)
#            p_x += (tmp.width - 30)
        
        width, height = director.get_window_size()
            
        obstacle = Sprite(pyglet.image.load(data.filepath('box_01.png')))
        obstacle.position = (380, 115)
        obstacle.image_anchor_y = 0
        self.stage_objects.append(obstacle)
        self.add(obstacle, z=101)
        obstacle.do(Repeat(MoveBy((width, 0), 10) + CallFuncS(self.box_offscreen)))
        
        self.level1()
        
        self.player = PlayerActor('standing', (650, 115))
        self.add(self.player, z=110)
        self.act()
        
        self.thug = ThugActor('walking', (750, 115))
        
        self.stage_objects.append(self.thug)
        self.add(self.thug, z=109)    
    def resetBG(self, target, position):
        target.position = position
    
    def box_offscreen(self, target):
        x, y = target.position
        width, height = director.get_window_size()
        if x < 0 or x > width:
            print 'box offscreen'
            #target.stop()
            self.remove(target)
            
    def act(self):
        if len(self.action_queue) > 0:
            target_act = self.action_queue.pop(0)
        else:
            target_act = PlayerDelay(1)
        print 'act', target_act
        self.player.do(target_act + CallFunc(self.act))
        
    def on_key_press(self, k , m ):
        if k == key.SPACE:
            self.way_points = []
        
    def on_mouse_press(self, x, y, btn, mod):
        mouse = MouseCursorRect((x,y), 20, 20)
        
        for obj in self.stage_objects:
            if (sprite_intersect(mouse, obj)):
                if (self.action_menu == None):
                    self.action_menu = Menu()
                    self.action_menu.menu_valign = CENTER
                    self.action_menu.menu_halign = CENTER
                    self.action_menu.items = []
                    action1 = PlayerJump((-60, 0), 60, 1, 2)
                    self.action_menu.items.append(MenuItem('Jump', self.addAction, action1))
                    
                    self.action_menu.create_menu(self.action_menu.items, zoom_in(), zoom_out())
                    self.action_menu.on_quit = self.close_action_menu
                    self.add(self.action_menu, 20)
    
    def addAction(self, act):
        print 'addAction ', self.action_queue
        self.action_queue.append(act)
        self.close_action_menu()
        
    def close_action_menu(self):
        print 'close action menu'
        self.remove(self.action_menu)
        self.action_menu = None
        
    def player_died(self):
        print 'died'
        self.player.stop()
        self.action_queue = []
        
        (obj.stop() for obj in self.stage_objects)
        
        director.pop()
        
    def level1(self):
        width, height = director.get_window_size()
        x_limit = width * 10
        x_spot = x_limit - (width / 2)
        self.level1 = ColorLayer(0, 0, 0, 50, width=x_limit, height=height)
        platform_img = pyglet.image.load(data.filepath('platform_01.png'))
        xp = 0
        z = 5
        while xp < x_limit + platform_img.width:
            pt1 = Sprite(platform_img)
            pt1.position = (((platform_img.width - 55) / 2) + xp, 20)
            print 'platform pos:', (platform_img.width - 55) / 2, pt1.position
            self.level1.add(pt1, z)
            xp += pt1.width - 30
            #z += 1
        self.add(self.level1, 20)
        self.level1.position = (-(x_limit - width), 20)
        print 'level1 pos:', self.level1.position
        self.level1.do((MoveBy((width, 0), 10)) * 10)
             
        
    def initBackgroundAnimation(self):
        #return True
        win_width, win_height = director.get_window_size()
        
        self.bg_0 = Sprite(pyglet.image.load(data.filepath('bg_0.png')))
        self.bg_0.position = (win_width / 2, win_height / 2)
        self.add(self.bg_0, 0)
        
        self.bg_1a = Sprite(pyglet.image.load(data.filepath('bg_1.png')))
        self.bg_1a.position = (win_width / 2, win_height / 2)
        self.add(self.bg_1a, 1)
        self.bg_1a.do(Repeat(MoveBy((self.bg_1a.width, 0), 10) + CallFuncS(self.resetBG, self.bg_1a.position)))
        
        self.bg_1b = Sprite(pyglet.image.load(data.filepath('bg_1.png')))
        self.bg_1b.position = (((win_width / 2) - self.bg_1b.width), win_height / 2)
        self.add(self.bg_1b, 1)
        self.bg_1b.do(Repeat(MoveBy((self.bg_1b.width, 0), 10) + CallFuncS(self.resetBG, self.bg_1b.position)))

        self.bg_1c = Sprite(pyglet.image.load(data.filepath('bg_1.png')))
        self.bg_1c.position = (((win_width / 2) - self.bg_1c.width * 2), win_height / 2)
        self.add(self.bg_1c, 1)
        self.bg_1c.do(Repeat(MoveBy((self.bg_1c.width, 0), 10) + CallFuncS(self.resetBG, self.bg_1c.position)))
        
        self.bg_2a = Sprite(pyglet.image.load(data.filepath('bg_2.png')))
        self.bg_2a.position = (win_width / 2, (win_height / 2))
        self.add(self.bg_2a, 2)
        self.bg_2a.do(Repeat(MoveBy((self.bg_2a.width, 0), 8) + CallFuncS(self.resetBG, self.bg_2a.position)))

        self.bg_2b = Sprite(pyglet.image.load(data.filepath('bg_2.png')))
        self.bg_2b.position = (((win_width / 2) - self.bg_2b.width), (win_height / 2))
        self.add(self.bg_2b, 2)
        self.bg_2b.do(Repeat(MoveBy((self.bg_2b.width, 0), 8) + CallFuncS(self.resetBG, self.bg_2b.position)))

        self.bg_2c = Sprite(pyglet.image.load(data.filepath('bg_2.png')))
        self.bg_2c.position = (((win_width / 2) - self.bg_2c.width * 2), (win_height / 2))
        self.add(self.bg_2c, 2)
        self.bg_2c.do(Repeat(MoveBy((self.bg_2c.width, 0), 8) + CallFuncS(self.resetBG, self.bg_2c.position)))

        self.bg_3a = Sprite(pyglet.image.load(data.filepath('bg_3.png')))
        self.bg_3a.position = (win_width / 2, (win_height / 2) + 10)
        self.add(self.bg_3a, 3)
        self.bg_3a.do(Repeat(MoveBy((self.bg_3a.width, 0), 6) + CallFuncS(self.resetBG, self.bg_3a.position)))

        self.bg_3b = Sprite(pyglet.image.load(data.filepath('bg_3.png')))
        self.bg_3b.position = (((win_width / 2) - self.bg_3b.width), (win_height / 2) + 10)
        self.add(self.bg_3b, 3)
        self.bg_3b.do(Repeat(MoveBy((self.bg_3b.width, 0), 6) + CallFuncS(self.resetBG, self.bg_3b.position)))

        self.bg_3c = Sprite(pyglet.image.load(data.filepath('bg_3.png')))
        self.bg_3c.position = (((win_width / 2) - self.bg_3c.width * 2), (win_height / 2) + 10)
        self.add(self.bg_3c, 3)
        self.bg_3c.do(Repeat(MoveBy((self.bg_3c.width, 0), 6) + CallFuncS(self.resetBG, self.bg_3c.position)))

